#!/bin/bash
# Author Rob Trew – Twitter @complexpoint Copyright 2017
jsScript=$(echo "$KMPARAM_omniJS_code")
kmVarsCS=$(echo -n "$KMPARAM_km_variables_used" | tr '\n' ',' | tr '\r' ',')
combined=$(echo "function omniJSContext (kmvar) {
        // pureOG :: a -> OG IO a
        const pureOG = v => (
            document.windows[0].selection.canvas.background.setUserData(
                'omniJSON', JSON.stringify(v, null, 2)
            ),
            v
        );
        function returnValue (kmvar) {
            document['kmvar'] = kmvar;
            $jsScript;
        };
        const v = returnValue(kmvar)
        pureOG(v);
        console.log(v);
    }")
osascript -l JavaScript <<JXA_END 2>/dev/null
    $combined
    
    // A list of functions applied to a list of arguments
    // <*> :: [(a -> b)] -> [a] -> [b]
    const ap = (fs, xs) => //
        [].concat.apply([], fs.map(f => //
            [].concat.apply([], xs.map(x => [f(x)]))));
            
    // foldl :: (b -> a -> b) -> b -> [a] -> b
    const foldl = (f, a, xs) => xs.reduce(f, a);
            
    // evaluateOGOmniJS :: (Options -> OG Maybe JSON String) -> {KeyValues}
    //      -> Maybe JSON String
    const evaluateOGOmniJS = (f, dctOptions) => {
        const
            a = Application.currentApplication(),
            sa = (a.includeStandardAdditions = true, a);

        // OMNIJS URL (FOR FUNCTION AND OPTIONS) ASSEMBLED, OPENED, COPIED
        ap([sa.openLocation], //
            ['omnigraffle:///omnijs-run?script=' +
                encodeURIComponent(
                    '(' + f.toString() + ')(' + JSON.stringify(dctOptions) + ')'
                )
            ]);

        // ANY RETURN VALUE HARVESTED FROM THE USER DATA OF THE BACKGROUND
        // canvasbackground.userData('omniJSON')
        const
            og = Application('OmniGraffle'),
            ws = (og.activate(), og.windows.where({
                _not: [{
                    name: {
                        _beginsWith: "Automation Console"
                    }
                }]
            })),
            mw = ws.length > 0 ? {
                just: ws.at(0),
                nothing: false
            } : {
                nothing: true
            },
            mResult = mw.nothing ? mw : (() => {
                const w = mw.just;
                return w.name()
                    .indexOf('Automation Console') === 0 ? ({
                        nothing: true,
                        msg: 'Front window was Automation Console'
                    }) : (() => {
                        const v = w.canvas()
                            .canvasbackground.userDataItems.byName('omniJSON')
                            .value()
                        return (v === undefined || v === null) ? '' : v;
                    })();
            })();
        return mResult.nothing ? mResult : (
            mw.just.canvas()
            .canvasbackground.userDataItems.byName('omniJSON')
            .value = null,
            mResult
        );
    };
    
    // KM VARIABLES REQUESTED FOR EXPORT TO OMNIJS
    const
        refVars = Application('Keyboard Maestro Engine').variables,
        dctVars = foldl(
            (a, k) => {
                v = refVars[k];
                return v.exists() ? (a[k] = v.value(), a) : a;
            },
            {},
            ('$kmVarsCS').split(',')
        );
        
    // FRONT DOCUMENT OF OMNIGRAFFLE
    const 
        og = Application('OmniGraffle'),
        ds = og.documents,
        d = ds.length > 0 ? ds.at(0) : ds.push(og.Document());
    
    // OMNIJS CODE EVALUATED, WITH A NAME SPACE POSSIBLY INCLUDING
    // SOME KM VARS
    og.activate() && evaluateOGOmniJS(omniJSContext, dctVars);
JXA_END

    